﻿using FinModel;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace FinMarketData
{
    /// <summary>
    /// name vs. market data entry
    /// </summary>
    public class MarketData : Dictionary<string, MarketDataEntry>
    {
        public double Rate { get; set; }

        public MarketDataEntry this[Instrument instrument]
        {
            get { return this[instrument.Name]; }
        }
    }

    /// <summary>
    /// market data entry
    /// </summary>
    public class MarketDataEntry
    {
        public double Price { get; set; }
        public double Vol { get; set; }
        public double Beta { get; set; }
    }
}
