﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using FinScreen.Util;
using SmartQuant.Series;
using SmartQuant.Indicators;
using SmartQuant.Data;
using FinScreen.Model;

namespace FinScreen.Analyzers
{
    [Strategy("三连阴购买策略", FinScreen.StrategyEnum.Buy)]
    class Down3DaysBuyStrategy : Strategy
    {
        public override IEnumerable<Instrument> Instrument(StrategyContext context)
        {
            int x = 6;
            return context.MasterBase
               .Where(p => !p.Name.Contains("ST") 
                   && p.Quotes != null 
                   && p.Quotes.Count > x 
                   && p.Quotes.Last().Close <= 15 
                   && p.Quotes.OrderByDescending(p1 => p1.TS).Take(x).All(p1 => p1.PctChange <= 0f))
               .ToList();
        }

        public override void OnMarket(QuantBox.CSharp2CTPZQ.CThostFtdcDepthMarketDataField data)
        {
        }
    }
}