﻿using System;
using System.Reactive.Subjects;

namespace FinScreen
{
    class Observable<T> : IObservable<T>
    {
        private readonly Subject<T> _subject = new Subject<T>();

        protected Observable()
        {
        }

        public IDisposable Subscribe(IObserver<T> observer)
        {
            return _subject.Subscribe(observer);
        }

        protected void OnNext(T obj)
        {
            _subject.OnNext(obj);
        }
    }
}
